diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/visualizer/visualizer/plugins/show_last_packets.py ns-3.39/src/visualizer/visualizer/plugins/show_last_packets.py
--- ns-3.38/src/visualizer/visualizer/plugins/show_last_packets.py	2023-03-16 20:54:23.844869400 -0700
+++ ns-3.39/src/visualizer/visualizer/plugins/show_last_packets.py	2023-07-05 14:23:48.101428300 -0700
@@ -3,7 +3,11 @@
 
 from ns import ns
 
-from visualizer.base import InformationWindow
+try:
+    from ns3.visualizer.base import InformationWindow
+except ModuleNotFoundError:
+    from visualizer.base import InformationWindow
+
 from kiwi.ui.objectlist import ObjectList, Column
 
 ## ShowLastPackets class
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/visualizer/visualizer/plugins/wifi_intrastructure_link.py ns-3.39/src/visualizer/visualizer/plugins/wifi_intrastructure_link.py
--- ns-3.38/src/visualizer/visualizer/plugins/wifi_intrastructure_link.py	2023-03-16 20:54:23.844869400 -0700
+++ ns-3.39/src/visualizer/visualizer/plugins/wifi_intrastructure_link.py	2023-07-05 14:23:48.101428300 -0700
@@ -1,7 +1,11 @@
 import math
 from ns import ns
 from gi.repository import GooCanvas
-from visualizer.base import Link, transform_distance_canvas_to_simulation
+
+try:
+    from ns3.visualizer.base import Link, transform_distance_canvas_to_simulation
+except ModuleNotFoundError:
+    from visualizer.base import Link, transform_distance_canvas_to_simulation
 
 ## WifiLink class
 class WifiLink(Link):
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/CMakeLists.txt ns-3.39/src/wifi/CMakeLists.txt
--- ns-3.38/src/wifi/CMakeLists.txt	2023-03-16 20:54:23.848869300 -0700
+++ ns-3.39/src/wifi/CMakeLists.txt	2023-07-05 14:23:48.101428300 -0700
@@ -25,6 +25,7 @@
     model/channel-access-manager.cc
     model/ctrl-headers.cc
     model/edca-parameter-set.cc
+    model/eht/default-emlsr-manager.cc
     model/eht/eht-capabilities.cc
     model/eht/eht-configuration.cc
     model/eht/eht-frame-exchange-manager.cc
@@ -32,6 +33,7 @@
     model/eht/tid-to-link-mapping-element.cc
     model/eht/eht-phy.cc
     model/eht/eht-ppdu.cc
+    model/eht/emlsr-manager.cc
     model/eht/multi-link-element.cc
     model/error-rate-model.cc
     model/extended-capabilities.cc
@@ -73,10 +75,10 @@
     model/non-ht/erp-ofdm-ppdu.cc
     model/non-ht/ofdm-phy.cc
     model/non-ht/ofdm-ppdu.cc
+    model/non-inheritance.cc
     model/originator-block-ack-agreement.cc
     model/phy-entity.cc
     model/preamble-detection-model.cc
-    model/qos-blocked-destinations.cc
     model/qos-frame-exchange-manager.cc
     model/qos-txop.cc
     model/qos-utils.cc
@@ -116,10 +118,10 @@
     model/wifi-ack-manager.cc
     model/wifi-acknowledgment.cc
     model/wifi-assoc-manager.cc
+    model/wifi-bandwidth-filter.cc
     model/wifi-default-ack-manager.cc
     model/wifi-default-assoc-manager.cc
     model/wifi-default-protection-manager.cc
-    model/wifi-information-element-vector.cc
     model/wifi-information-element.cc
     model/wifi-mac-header.cc
     model/wifi-mac-queue-container.cc
@@ -174,6 +176,7 @@
     model/channel-access-manager.h
     model/ctrl-headers.h
     model/edca-parameter-set.h
+    model/eht/default-emlsr-manager.h
     model/eht/eht-capabilities.h
     model/eht/eht-configuration.h
     model/eht/eht-frame-exchange-manager.h
@@ -181,6 +184,7 @@
     model/eht/tid-to-link-mapping-element.h
     model/eht/eht-phy.h
     model/eht/eht-ppdu.h
+    model/eht/emlsr-manager.h
     model/eht/multi-link-element.h
     model/error-rate-model.h
     model/extended-capabilities.h
@@ -222,10 +226,10 @@
     model/non-ht/erp-ofdm-ppdu.h
     model/non-ht/ofdm-phy.h
     model/non-ht/ofdm-ppdu.h
+    model/non-inheritance.h
     model/originator-block-ack-agreement.h
     model/phy-entity.h
     model/preamble-detection-model.h
-    model/qos-blocked-destinations.h
     model/qos-frame-exchange-manager.h
     model/qos-txop.h
     model/qos-utils.h
@@ -266,10 +270,10 @@
     model/wifi-ack-manager.h
     model/wifi-acknowledgment.h
     model/wifi-assoc-manager.h
+    model/wifi-bandwidth-filter.h
     model/wifi-default-ack-manager.h
     model/wifi-default-assoc-manager.h
     model/wifi-default-protection-manager.h
-    model/wifi-information-element-vector.h
     model/wifi-information-element.h
     model/wifi-mac-header.h
     model/wifi-mac-queue-container.h
@@ -279,6 +283,7 @@
     model/wifi-mac-queue.h
     model/wifi-mac-trailer.h
     model/wifi-mac.h
+    model/wifi-mgt-header.h
     model/wifi-mode.h
     model/wifi-mpdu-type.h
     model/wifi-mpdu.h
@@ -332,6 +337,7 @@
     test/wifi-aggregation-test.cc
     test/wifi-dynamic-bw-op-test.cc
     test/wifi-eht-info-elems-test.cc
+    test/wifi-emlsr-test.cc
     test/wifi-error-rate-models-test.cc
     test/wifi-ie-fragment-test.cc
     test/wifi-mac-ofdma-test.cc
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/examples/wifi-manager-example.cc ns-3.39/src/wifi/examples/wifi-manager-example.cc
--- ns-3.38/src/wifi/examples/wifi-manager-example.cc	2023-03-16 20:54:23.852869300 -0700
+++ ns-3.39/src/wifi/examples/wifi-manager-example.cc	2023-07-05 14:23:48.105428500 -0700
@@ -277,7 +277,7 @@
     std::cout << "Run 'wifi-manager-example --PrintHelp' to show program options." << std::endl
               << std::endl;
 
-    if (infrastructure == false)
+    if (!infrastructure)
     {
         NS_ABORT_MSG_IF(serverNss != clientNss,
                         "In ad hoc mode, we assume sender and receiver are similarly configured");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/examples/wifi-phy-test.cc ns-3.39/src/wifi/examples/wifi-phy-test.cc
--- ns-3.38/src/wifi/examples/wifi-phy-test.cc	2023-03-16 20:54:23.852869300 -0700
+++ ns-3.39/src/wifi/examples/wifi-phy-test.cc	2023-07-05 14:23:48.105428500 -0700
@@ -59,7 +59,7 @@
      * \param input the PSR experiment
      * \returns the PSR experiment output
      */
-    struct PsrExperiment::Output Run(struct PsrExperiment::Input input);
+    PsrExperiment::Output Run(PsrExperiment::Input input);
 
   private:
     /// Send function
@@ -114,8 +114,8 @@
 {
 }
 
-struct PsrExperiment::Output
-PsrExperiment::Run(struct PsrExperiment::Input input)
+PsrExperiment::Output
+PsrExperiment::Run(PsrExperiment::Input input)
 {
     m_output.received = 0;
     m_input = input;
@@ -189,7 +189,7 @@
      * \param input the collision experiment data
      * \returns the experiment output
      */
-    struct CollisionExperiment::Output Run(struct CollisionExperiment::Input input);
+    CollisionExperiment::Output Run(CollisionExperiment::Input input);
 
   private:
     /// Send A function
@@ -277,8 +277,8 @@
 {
 }
 
-struct CollisionExperiment::Output
-CollisionExperiment::Run(struct CollisionExperiment::Input input)
+CollisionExperiment::Output
+CollisionExperiment::Run(CollisionExperiment::Input input)
 {
     m_output.receivedA = 0;
     m_output.receivedB = 0;
@@ -339,7 +339,7 @@
 PrintPsr(int argc, char* argv[])
 {
     PsrExperiment experiment;
-    struct PsrExperiment::Input input;
+    PsrExperiment::Input input;
 
     CommandLine cmd(__FILE__);
     cmd.AddValue("Distance", "The distance between two phys", input.distance);
@@ -351,7 +351,7 @@
                  input.txPowerLevel);
     cmd.Parse(argc, argv);
 
-    struct PsrExperiment::Output output;
+    PsrExperiment::Output output;
     output = experiment.Run(input);
 
     double psr = output.received;
@@ -361,7 +361,7 @@
 }
 
 double
-CalcPsr(struct PsrExperiment::Output output, struct PsrExperiment::Input input)
+CalcPsr(PsrExperiment::Output output, PsrExperiment::Input input)
 {
     double psr = output.received;
     psr /= input.nPackets;
@@ -371,7 +371,7 @@
 static void
 PrintPsrVsDistance(int argc, char* argv[])
 {
-    struct PsrExperiment::Input input;
+    PsrExperiment::Input input;
     CommandLine cmd(__FILE__);
     cmd.AddValue("TxPowerLevel",
                  "The power level index to use to send each packet",
@@ -385,7 +385,7 @@
     {
         std::cout << input.distance;
         PsrExperiment experiment;
-        struct PsrExperiment::Output output;
+        PsrExperiment::Output output;
 
         input.txMode = "OfdmRate6Mbps";
         output = experiment.Run(input);
@@ -427,7 +427,7 @@
 PrintSizeVsRange(int argc, char* argv[])
 {
     double targetPsr = 0.05;
-    struct PsrExperiment::Input input;
+    PsrExperiment::Input input;
     CommandLine cmd(__FILE__);
     cmd.AddValue("TxPowerLevel",
                  "The power level index to use to send each packet",
@@ -445,7 +445,7 @@
         while (high - low > precision)
         {
             double middle = low + (high - low) / 2;
-            struct PsrExperiment::Output output;
+            PsrExperiment::Output output;
             PsrExperiment experiment;
             input.distance = middle;
             output = experiment.Run(input);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/examples/wifi-test-interference-helper.cc ns-3.39/src/wifi/examples/wifi-test-interference-helper.cc
--- ns-3.38/src/wifi/examples/wifi-test-interference-helper.cc	2023-03-16 20:54:23.852869300 -0700
+++ ns-3.39/src/wifi/examples/wifi-test-interference-helper.cc	2023-07-05 14:23:48.105428500 -0700
@@ -108,7 +108,7 @@
      * Run function
      * \param input the interference experiment data
      */
-    void Run(struct InterferenceExperiment::Input input);
+    void Run(InterferenceExperiment::Input input);
 
   private:
     /**
@@ -213,12 +213,12 @@
 }
 
 void
-InterferenceExperiment::Run(struct InterferenceExperiment::Input input)
+InterferenceExperiment::Run(InterferenceExperiment::Input input)
 {
     m_input = input;
 
-    double range = std::max(std::abs(input.xA), input.xB);
-    Config::SetDefault("ns3::RangePropagationLossModel::MaxRange", DoubleValue(range));
+    double maxRange = std::max(std::abs(input.xA), input.xB);
+    Config::SetDefault("ns3::RangePropagationLossModel::MaxRange", DoubleValue(maxRange));
 
     Ptr<SingleModelSpectrumChannel> channel = CreateObject<SingleModelSpectrumChannel>();
     channel->SetPropagationDelayModel(CreateObject<ConstantSpeedPropagationDelayModel>());
@@ -235,7 +235,6 @@
     Ptr<Node> nodeA = CreateObject<Node>();
     Ptr<WifiNetDevice> devA = CreateObject<WifiNetDevice>();
     m_txA = CreateObject<SpectrumWifiPhy>();
-    m_txA->CreateWifiSpectrumPhyInterface(devA);
     m_txA->SetDevice(devA);
     m_txA->SetTxPowerStart(input.txPowerLevelA);
     m_txA->SetTxPowerEnd(input.txPowerLevelA);
@@ -243,7 +242,6 @@
     Ptr<Node> nodeB = CreateObject<Node>();
     Ptr<WifiNetDevice> devB = CreateObject<WifiNetDevice>();
     m_txB = CreateObject<SpectrumWifiPhy>();
-    m_txB->CreateWifiSpectrumPhyInterface(devB);
     m_txB->SetDevice(devB);
     m_txB->SetTxPowerStart(input.txPowerLevelB);
     m_txB->SetTxPowerEnd(input.txPowerLevelB);
@@ -251,7 +249,6 @@
     Ptr<Node> nodeRx = CreateObject<Node>();
     Ptr<WifiNetDevice> devRx = CreateObject<WifiNetDevice>();
     Ptr<SpectrumWifiPhy> rx = CreateObject<SpectrumWifiPhy>();
-    rx->CreateWifiSpectrumPhyInterface(devRx);
     rx->SetDevice(devRx);
 
     Ptr<InterferenceHelper> interferenceTxA = CreateObject<InterferenceHelper>();
@@ -266,9 +263,9 @@
     rx->SetInterferenceHelper(interferenceRx);
     Ptr<ErrorRateModel> errorRx = CreateObject<NistErrorRateModel>();
     rx->SetErrorRateModel(errorRx);
-    m_txA->SetChannel(channel);
-    m_txB->SetChannel(channel);
-    rx->SetChannel(channel);
+    m_txA->AddChannel(channel);
+    m_txB->AddChannel(channel);
+    rx->AddChannel(channel);
     m_txA->SetMobility(posTxA);
     m_txB->SetMobility(posTxB);
     rx->SetMobility(posRx);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/helper/spectrum-wifi-helper.cc ns-3.39/src/wifi/helper/spectrum-wifi-helper.cc
--- ns-3.38/src/wifi/helper/spectrum-wifi-helper.cc	2023-03-16 20:54:23.852869300 -0700
+++ ns-3.39/src/wifi/helper/spectrum-wifi-helper.cc	2023-07-05 14:23:48.105428500 -0700
@@ -27,8 +27,12 @@
 #include "ns3/mobility-model.h"
 #include "ns3/names.h"
 #include "ns3/preamble-detection-model.h"
+#include "ns3/spectrum-channel.h"
+#include "ns3/spectrum-transmit-filter.h"
 #include "ns3/spectrum-wifi-phy.h"
+#include "ns3/wifi-bandwidth-filter.h"
 #include "ns3/wifi-net-device.h"
+#include "ns3/wifi-spectrum-value-helper.h"
 
 namespace ns3
 {
@@ -43,41 +47,65 @@
     {
         phy.SetTypeId("ns3::SpectrumWifiPhy");
     }
-    m_channels.resize(m_phy.size());
     SetInterferenceHelper("ns3::InterferenceHelper");
     SetErrorRateModel("ns3::TableBasedErrorRateModel");
 }
 
 void
-SpectrumWifiPhyHelper::SetChannel(Ptr<SpectrumChannel> channel)
+SpectrumWifiPhyHelper::SetChannel(const Ptr<SpectrumChannel> channel)
 {
-    for (auto& ch : m_channels)
-    {
-        ch = channel;
-    }
+    m_channels[WHOLE_WIFI_SPECTRUM] = channel;
+    AddWifiBandwidthFilter(channel);
 }
 
 void
-SpectrumWifiPhyHelper::SetChannel(std::string channelName)
+SpectrumWifiPhyHelper::SetChannel(const std::string& channelName)
 {
     Ptr<SpectrumChannel> channel = Names::Find<SpectrumChannel>(channelName);
-    for (auto& ch : m_channels)
-    {
-        ch = channel;
-    }
+    m_channels[WHOLE_WIFI_SPECTRUM] = channel;
+    AddWifiBandwidthFilter(channel);
 }
 
 void
-SpectrumWifiPhyHelper::SetChannel(uint8_t linkId, Ptr<SpectrumChannel> channel)
+SpectrumWifiPhyHelper::AddChannel(const Ptr<SpectrumChannel> channel,
+                                  const FrequencyRange& freqRange)
 {
-    m_channels.at(linkId) = channel;
+    m_channels[freqRange] = channel;
+    AddWifiBandwidthFilter(channel);
 }
 
 void
-SpectrumWifiPhyHelper::SetChannel(uint8_t linkId, std::string channelName)
+SpectrumWifiPhyHelper::AddChannel(const std::string& channelName, const FrequencyRange& freqRange)
 {
     Ptr<SpectrumChannel> channel = Names::Find<SpectrumChannel>(channelName);
-    m_channels.at(linkId) = channel;
+    AddChannel(channel, freqRange);
+    AddWifiBandwidthFilter(channel);
+}
+
+void
+SpectrumWifiPhyHelper::AddWifiBandwidthFilter(Ptr<SpectrumChannel> channel)
+{
+    Ptr<const SpectrumTransmitFilter> p = channel->GetSpectrumTransmitFilter();
+    bool found = false;
+    while (p && !found)
+    {
+        if (DynamicCast<const WifiBandwidthFilter>(p))
+        {
+            NS_LOG_DEBUG("Found existing WifiBandwidthFilter for channel " << channel);
+            found = true;
+        }
+        else
+        {
+            NS_LOG_DEBUG("Found different SpectrumTransmitFilter for channel " << channel);
+            p = p->GetNext();
+        }
+    }
+    if (!found)
+    {
+        Ptr<WifiBandwidthFilter> pWifi = CreateObject<WifiBandwidthFilter>();
+        channel->AddSpectrumTransmitFilter(pWifi);
+        NS_LOG_DEBUG("Adding WifiBandwidthFilter to channel " << channel);
+    }
 }
 
 std::vector<Ptr<WifiPhy>>
@@ -88,7 +116,6 @@
     for (std::size_t i = 0; i < m_phy.size(); i++)
     {
         Ptr<SpectrumWifiPhy> phy = m_phy.at(i).Create<SpectrumWifiPhy>();
-        phy->CreateWifiSpectrumPhyInterface(device);
         auto interference = m_interferenceHelper.Create<InterferenceHelper>();
         phy->SetInterferenceHelper(interference);
         Ptr<ErrorRateModel> error = m_errorRateModel.at(i).Create<ErrorRateModel>();
@@ -104,7 +131,10 @@
                 m_preambleDetectionModel.at(i).Create<PreambleDetectionModel>();
             phy->SetPreambleDetectionModel(preambleDetection);
         }
-        phy->SetChannel(m_channels.at(i));
+        for (const auto& [freqRange, channel] : m_channels)
+        {
+            phy->AddChannel(channel, freqRange);
+        }
         phy->SetDevice(device);
         phy->SetMobility(node->GetObject<MobilityModel>());
         ret.emplace_back(phy);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/helper/wifi-helper.cc ns-3.39/src/wifi/helper/wifi-helper.cc
--- ns-3.38/src/wifi/helper/wifi-helper.cc	2023-03-16 20:54:23.852869300 -0700
+++ ns-3.39/src/wifi/helper/wifi-helper.cc	2023-07-05 14:23:48.105428500 -0700
@@ -377,7 +377,7 @@
         packet->RemoveHeader(hdr);
         extractedLength = hdr.GetLength();
         packet = packet->CreateFragment(0, static_cast<uint32_t>(extractedLength));
-        if (aMpdu.type == LAST_MPDU_IN_AGGREGATE || (hdr.GetEof() == true && hdr.GetLength() > 0))
+        if (aMpdu.type == LAST_MPDU_IN_AGGREGATE || (hdr.GetEof() && hdr.GetLength() > 0))
         {
             ampduStatusFlags |= RadiotapHeader::A_MPDU_STATUS_LAST;
         }
@@ -890,21 +890,21 @@
     LogComponentEnable("AparfWifiManager", LOG_LEVEL_ALL);
     LogComponentEnable("ArfWifiManager", LOG_LEVEL_ALL);
     LogComponentEnable("BlockAckAgreement", LOG_LEVEL_ALL);
-    LogComponentEnable("RecipientBlockAckAgreement", LOG_LEVEL_ALL);
     LogComponentEnable("BlockAckManager", LOG_LEVEL_ALL);
     LogComponentEnable("CaraWifiManager", LOG_LEVEL_ALL);
     LogComponentEnable("ChannelAccessManager", LOG_LEVEL_ALL);
     LogComponentEnable("ConstantObssPdAlgorithm", LOG_LEVEL_ALL);
     LogComponentEnable("ConstantRateWifiManager", LOG_LEVEL_ALL);
-    LogComponentEnable("ChannelAccessManager", LOG_LEVEL_ALL);
+    LogComponentEnable("DefaultEmlsrManager", LOG_LEVEL_ALL);
     LogComponentEnable("DsssErrorRateModel", LOG_LEVEL_ALL);
     LogComponentEnable("DsssPhy", LOG_LEVEL_ALL);
     LogComponentEnable("DsssPpdu", LOG_LEVEL_ALL);
     LogComponentEnable("EhtFrameExchangeManager", LOG_LEVEL_ALL);
-    LogComponentEnable("ErpOfdmPhy", LOG_LEVEL_ALL);
-    LogComponentEnable("ErpOfdmPpdu", LOG_LEVEL_ALL);
     LogComponentEnable("EhtPhy", LOG_LEVEL_ALL);
     LogComponentEnable("EhtPpdu", LOG_LEVEL_ALL);
+    LogComponentEnable("EmlsrManager", LOG_LEVEL_ALL);
+    LogComponentEnable("ErpOfdmPhy", LOG_LEVEL_ALL);
+    LogComponentEnable("ErpOfdmPpdu", LOG_LEVEL_ALL);
     LogComponentEnable("FrameExchangeManager", LOG_LEVEL_ALL);
     LogComponentEnable("HeConfiguration", LOG_LEVEL_ALL);
     LogComponentEnable("HeFrameExchangeManager", LOG_LEVEL_ALL);
@@ -926,15 +926,16 @@
     LogComponentEnable("NistErrorRateModel", LOG_LEVEL_ALL);
     LogComponentEnable("ObssPdAlgorithm", LOG_LEVEL_ALL);
     LogComponentEnable("OfdmPhy", LOG_LEVEL_ALL);
+    LogComponentEnable("OfdmPpdu", LOG_LEVEL_ALL);
     LogComponentEnable("OnoeWifiManager", LOG_LEVEL_ALL);
     LogComponentEnable("OriginatorBlockAckAgreement", LOG_LEVEL_ALL);
-    LogComponentEnable("OfdmPpdu", LOG_LEVEL_ALL);
     LogComponentEnable("ParfWifiManager", LOG_LEVEL_ALL);
     LogComponentEnable("PhyEntity", LOG_LEVEL_ALL);
     LogComponentEnable("QosFrameExchangeManager", LOG_LEVEL_ALL);
     LogComponentEnable("QosTxop", LOG_LEVEL_ALL);
-    LogComponentEnable("RraaWifiManager", LOG_LEVEL_ALL);
+    LogComponentEnable("RecipientBlockAckAgreement", LOG_LEVEL_ALL);
     LogComponentEnable("RrMultiUserScheduler", LOG_LEVEL_ALL);
+    LogComponentEnable("RraaWifiManager", LOG_LEVEL_ALL);
     LogComponentEnable("RrpaaWifiManager", LOG_LEVEL_ALL);
     LogComponentEnable("SimpleFrameCaptureModel", LOG_LEVEL_ALL);
     LogComponentEnable("SpectrumWifiPhy", LOG_LEVEL_ALL);
@@ -958,8 +959,8 @@
     LogComponentEnable("WifiMpdu", LOG_LEVEL_ALL);
     LogComponentEnable("WifiNetDevice", LOG_LEVEL_ALL);
     LogComponentEnable("WifiPhyStateHelper", LOG_LEVEL_ALL);
-    LogComponentEnable("WifiPhy", LOG_LEVEL_ALL);
     LogComponentEnable("WifiPhyOperatingChannel", LOG_LEVEL_ALL);
+    LogComponentEnable("WifiPhy", LOG_LEVEL_ALL);
     LogComponentEnable("WifiPpdu", LOG_LEVEL_ALL);
     LogComponentEnable("WifiProtectionManager", LOG_LEVEL_ALL);
     LogComponentEnable("WifiPsdu", LOG_LEVEL_ALL);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/helper/wifi-helper.h ns-3.39/src/wifi/helper/wifi-helper.h
--- ns-3.38/src/wifi/helper/wifi-helper.h	2023-03-16 20:54:51.628957000 -0700
+++ ns-3.39/src/wifi/helper/wifi-helper.h	2023-07-05 14:23:48.105428500 -0700
@@ -24,7 +24,6 @@
 
 #include "wifi-mac-helper.h"
 
-#include "ns3/deprecated.h"
 #include "ns3/qos-utils.h"
 #include "ns3/trace-helper.h"
 #include "ns3/wifi-phy.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/helper/wifi-mac-helper.cc ns-3.39/src/wifi/helper/wifi-mac-helper.cc
--- ns-3.38/src/wifi/helper/wifi-mac-helper.cc	2023-03-16 20:54:23.852869300 -0700
+++ ns-3.39/src/wifi/helper/wifi-mac-helper.cc	2023-07-05 14:23:48.105428500 -0700
@@ -20,6 +20,8 @@
 #include "wifi-mac-helper.h"
 
 #include "ns3/boolean.h"
+#include "ns3/eht-configuration.h"
+#include "ns3/emlsr-manager.h"
 #include "ns3/frame-exchange-manager.h"
 #include "ns3/multi-user-scheduler.h"
 #include "ns3/wifi-ack-manager.h"
@@ -40,6 +42,7 @@
     m_queueScheduler.SetTypeId("ns3::FcfsWifiQueueScheduler");
     m_protectionManager.SetTypeId("ns3::WifiDefaultProtectionManager");
     m_ackManager.SetTypeId("ns3::WifiDefaultAckManager");
+    m_emlsrManager.SetTypeId("ns3::DefaultEmlsrManager");
 }
 
 WifiMacHelper::~WifiMacHelper()
@@ -67,9 +70,9 @@
     Ptr<WifiMacQueueScheduler> queueScheduler = m_queueScheduler.Create<WifiMacQueueScheduler>();
     mac->SetMacQueueScheduler(queueScheduler);
 
-    // WaveNetDevice stores PHY entities in a different member than WifiNetDevice, hence
-    // GetNPhys() would return 0. We have to attach a protection manager and an ack manager
-    // to the unique instance of frame exchange manager anyway
+    // WaveNetDevice (through ns-3.38) stores PHY entities in a different member than WifiNetDevice,
+    // hence GetNPhys() would return 0. We have to attach a protection manager and an ack manager to
+    // the unique instance of frame exchange manager anyway
     for (uint8_t linkId = 0; linkId < std::max<uint8_t>(device->GetNPhys(), 1); ++linkId)
     {
         auto fem = mac->GetFrameExchangeManager(linkId);
@@ -107,12 +110,23 @@
     }
 
     // create and install the Association Manager if this is a STA
-    if (auto staMac = DynamicCast<StaWifiMac>(mac); staMac != nullptr)
+    auto staMac = DynamicCast<StaWifiMac>(mac);
+    if (staMac)
     {
         Ptr<WifiAssocManager> assocManager = m_assocManager.Create<WifiAssocManager>();
         staMac->SetAssocManager(assocManager);
     }
 
+    // create and install the EMLSR Manager if this is an EHT non-AP MLD with EMLSR activated
+    if (BooleanValue emlsrActivated;
+        standard >= WIFI_STANDARD_80211be && staMac && staMac->GetNLinks() > 1 &&
+        device->GetEhtConfiguration()->GetAttributeFailSafe("EmlsrActivated", emlsrActivated) &&
+        emlsrActivated.Get())
+    {
+        auto emlsrManager = m_emlsrManager.Create<EmlsrManager>();
+        staMac->SetEmlsrManager(emlsrManager);
+    }
+
     return mac;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/helper/wifi-mac-helper.h ns-3.39/src/wifi/helper/wifi-mac-helper.h
--- ns-3.38/src/wifi/helper/wifi-mac-helper.h	2023-03-16 20:54:23.852869300 -0700
+++ ns-3.39/src/wifi/helper/wifi-mac-helper.h	2023-07-05 14:23:48.105428500 -0700
@@ -120,6 +120,16 @@
     void SetMultiUserScheduler(std::string type, Args&&... args);
 
     /**
+     * Helper function used to set the EMLSR Manager that can be installed on an EHT non-AP MLD.
+     *
+     * \tparam Args \deduced Template type parameter pack for the sequence of name-value pairs.
+     * \param type the type of EMLSR Manager
+     * \param args A sequence of name-value pairs of the attributes to set.
+     */
+    template <typename... Args>
+    void SetEmlsrManager(std::string type, Args&&... args);
+
+    /**
      * \param device the device within which the MAC object will reside
      * \param standard the standard to configure during installation
      * \returns a new MAC object.
@@ -135,6 +145,7 @@
     ObjectFactory m_protectionManager; ///< Factory to create a protection manager
     ObjectFactory m_ackManager;        ///< Factory to create an acknowledgment manager
     ObjectFactory m_muScheduler;       ///< Multi-user Scheduler object factory
+    ObjectFactory m_emlsrManager;      ///< EMLSR Manager object factory
 };
 
 } // namespace ns3
@@ -194,6 +205,14 @@
     m_muScheduler.Set(args...);
 }
 
+template <typename... Args>
+void
+WifiMacHelper::SetEmlsrManager(std::string type, Args&&... args)
+{
+    m_emlsrManager.SetTypeId(type);
+    m_emlsrManager.Set(args...);
+}
+
 } // namespace ns3
 
 #endif /* WIFI_MAC_HELPER_H */
